#if !defined MSG_REQUESTLEXER_HH_
#define MSG_REQUESTLEXER_HH_

using namespace std;

// ---------- String tools ----------

static string& str_replace(const string &search, const string &replace, string &subject) {
    string buffer;
    int sealeng = search.length();
    int strleng = subject.length();
    if (sealeng==0) return subject;
    for(int i=0, j=0; i<strleng; j=0 ) {
        while (i+j<strleng && j<sealeng && subject[i+j]==search[j]) j++;
        if (j==sealeng) {buffer.append(replace); i+=sealeng;}
        else buffer.append( &subject[i++], 1);
    }
    subject = buffer;
    return subject;
}

static string& removeFormatting(string &s) {
	return str_replace(" ", "", s);
}

// ---------- Default parsing ----------

static const string SPACE		= "[[:space:]]";
static const string WORD		= "([[:word:]]+)";

static const string LSCOPE		= "[{]";
static const string RSCOPE		= "[}]";
static const string LBRAC		= "[[.left-square-bracket.]]";
static const string RBRAC		= "[[.right-square-bracket.]]";
static const string JSEP		= "[[.colon.]]";
static const string COMMA		= "[[.comma.]]";
static const string QUOTE		= "[[.quotation-mark.]]";
static const string STRING		= QUOTE + WORD + QUOTE;
static const string NUMBER		= "([[:digit:]]+)";
static const string SLIST		= LBRAC + "((("+STRING+")|(" + STRING + COMMA + "))*)" + RBRAC;

// ---------- Request parsing  ----------

static const string K_NULL		= "null";
static const string K_ONTOREQ	= QUOTE + "ONTO-REQ" + QUOTE;
static const string K_AGENT		= QUOTE + "AGENT" + QUOTE;
static const string K_OBJECT	= QUOTE + "OBJECT" + QUOTE;
static const string K_PROPERTY	= QUOTE + "PROPERTY" + QUOTE;

static const string AGENT		= K_AGENT + JSEP + STRING;
static const string AGNULL		= K_AGENT + JSEP + K_NULL;
static const string OBJECT		= K_OBJECT + JSEP + STRING;
static const string PROPERTY	= K_PROPERTY + JSEP + STRING;

static const string ONTOFIND	= LSCOPE + K_ONTOREQ + JSEP + LSCOPE + AGNULL + COMMA + OBJECT + COMMA + PROPERTY + RSCOPE + RSCOPE;
static const string ONTOFFA		= LSCOPE + K_ONTOREQ + JSEP + LSCOPE + AGENT + COMMA + OBJECT + COMMA + PROPERTY + RSCOPE + RSCOPE;

// ---------- REGULAR EXPRESSION  ----------

static const boost::regex FindRequest(ONTOFIND);
static const boost::regex FindForAgentRequest(ONTOFFA);

#endif
