#include <iostream>

#include <boost/lexical_cast.hpp>

#include <msgServer.hh>

void printUsage(std::string name){
	std::cerr<<"Usage : "<<name<<" [address port [max_connections]]"<<std::endl;
	std::cerr<<"\taddress : Address of the server."<<std::endl;
	std::cerr<<"\tport : Port of the server."<<std::endl;
	std::cerr<<"\tmax_connections : Maximum number of clients that can connect at the same time."<<std::endl;
	exit(50);
}

int main(int argc, char ** argv){
//	//TODO Replace this with boost::program_option
	std::string address="localhost";
	std::string port="5500";
	int maximumConnections=MAX_CLIENT_CONNECTIONS;
	switch(argc){
		case 1: break;
		case 3: address=argv[1];
			port=argv[2];
			break;
		case 4: try{
				maximumConnections=boost::lexical_cast<unsigned long int>(argv[3]);
			}catch(boost::bad_lexical_cast& e){
				std::cerr<<"Value \""<<argv[3]<<"\" is not possible as parameter, only an integer value is acceptable for maximum number of clients."<<std::endl;
				return(98);
			}
			break;
		default: printUsage(argv[0]);
			break;
	}

	msgServer serveur(address, port, DEFAULT_SERVER_INACTIVITY_TIME, maximumConnections);
	serveur.run();
}
